       IDENTIFICATION DIVISION.
       PROGRAM-ID. A4.
      *
      ****************************************************************
      * EINGABEDATEN: VERTRETERUMSATZDATEI
      *      AUFBAU:
      *        1 -  6 ( 6) ... VERTRETERNUMMER
      *        7 - 35 (29) ... VERTRETERNAME
      *       36 - 46 (11) ... VERTRETERUMSATZ (2 NACHKOMMASTELLEN)
      *---------------------------------------------------------------
      * AUSGABEDATEN: VERTRETERUMSATZLISTE
      *      AUFBAU:
      *        1 SPALTENBERSCHRIFT UND
      *        1 LEERZEILE
      *
      *        1 ZEILE PRO VERTRETER MIT
      *            LAUFENDER NUMMER
      *            VERTRETERNAME
      *            VERTRETERUMSATZ
      *            VERTRETERNUMMER
      *
      * PRO SEITE MAXIMAL 66 ZEILEN (EINSCHL. BERSCHRIFT + LEERZEILE)
      * DIE BERSCHRIFT SOLL NIE ALLEIN AUF EINER SEITE STEHEN.
      ****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT VERTRET ASSIGN TO VERTRET.
           SELECT VLISTE  ASSIGN TO VLISTE.
      *
       DATA DIVISION.
       FILE SECTION.
      *
       FD  VERTRET.
       01  EIN.
           02 ENR    PIC X(6).
           02 ENAM   PIC X(29).
           02 EUMS   PIC 9(9)V99.
      *
       FD  VLISTE.
       01  DBER      PIC X(64).
      *
       WORKING-STORAGE SECTION.
       01  UEB.
           02 FILLER PIC X(11)   VALUE " LFDE.NR.".
           02 FILLER PIC X(30)   VALUE "V E R T R E T E R N A M E".
           02 FILLER PIC X(17)   VALUE "VERTRETERUMSATZ".
           02 FILLER PIC X(6)    VALUE "NUMMER".
      *
       01  AUS.
           02 FILLER PIC X(2)    VALUE SPACE.
           02 ALF    PIC ZZZZZ9.
           02 FILLER PIC X(3)    VALUE SPACE.
           02 ANAM   PIC X(29).
           02 FILLER PIC X(3)    VALUE SPACE.
           02 AUMS   PIC 9(9)V99.
           02 FILLER PIC X(4)    VALUE SPACE.
           02 ANR    PIC X(6).
      *
       77  ZZG       PIC 99      VALUE 66   COMP-3.
       77  ZZ        PIC 99                 COMP-3.
      *
       77  RLF       PIC 999999  VALUE 0    COMP-3.
      *
       77  K0        PIC 9       VALUE 0    COMP-3.
       77  K1        PIC 9       VALUE 1    COMP-3.
       77  K2        PIC 9       VALUE 2    COMP-3.
      *
       77  EOF       PIC 9       VALUE 0.
      *
       PROCEDURE DIVISION.
       ANFANG.
      *
           OPEN INPUT VERTRET OUTPUT VLISTE.
      *
           COMPUTE ZZ = ZZG.
           READ VERTRET AT END MOVE 1 TO EOF.
           PERFORM WITH TEST BEFORE UNTIL EOF = 1
               COMPUTE RLF = RLF + K1
               MOVE RLF TO ALF
               MOVE ENAM TO ANAM
               MOVE EUMS TO AUMS
               MOVE ENR TO ANR
               IF ZZ NOT LESS ZZG THEN
                   WRITE DBER FROM UEB AFTER PAGE
                   MOVE SPACE TO DBER
                   WRITE DBER AFTER 1
                   COMPUTE ZZ = K2
               END-IF
               WRITE DBER FROM AUS AFTER 1
               COMPUTE ZZ = ZZ + K1
               READ VERTRET AT END MOVE 1 TO EOF
               END-READ
           END-PERFORM.
      *
           CLOSE VERTRET VLISTE.
           STOP RUN.
