       IDENTIFICATION DIVISION.
       PROGRAM-ID. A8.
      *
      ****************************************************************
      * EINGABEDATEN: SCHLERDATEI
      *      AUFBAU:
      *        1 - 20 (20) ... FAMILIENNAME
      *       21 - 30 (10) ... VORNAME
      *          31   ( 1) ... GESCHLECHT
      *       32 - 39 ( 8) ... GEBURTSDATUM (IN DER FORM JJJJMMTT)
      *       40 - 41 ( 2) ... RELIGION (VERSCHLSSELT)
      *       42 - 44 ( 3) ... STAATSBRGERSCHAFT
      *       45 - 49 ( 5) ... KLASSE
      *       50 - 53 ( 4) ... POSTLEITZAHL
      *       54 - 65 (12) ... ORT
      *       66 - 80 (15) ... STRASSE
      *---------------------------------------------------------------
      * AUSGABEDATEN: SCHLERLISTE FR DIE KLASSE 1BKDV
      *      AUFBAU:
      *        1 HAUPTBERSCHRIFT MIT DER AUSGEWHLTEN KLASSE
      *        1 LEERZEILE
      *        1 SPALTENBERSCHRIFT
      *        1 LEERZEILE
      *
      *        1 ZEILE FR JEDEN SCHLER AUS DER KLASSE 1BKDV.
      *            JEDE ZEILE MIT
      *               LAUFENDER NUMMER
      *               FAMILIENNAME
      *               VORNAME
      *               GEBURTSDATUM (NUR BEI MNNLICHEN SCHLERN!)
      *
      * PRO SEITE MAXIMAL 20 ZEILEN (EINSCHL. BERSCHRIFT + LEERZEILE)
      * DIE BERSCHRIFT SOLL NIE ALLEIN AUF EINER SEITE STEHEN.
      ****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT SCHULE ASSIGN TO SCHULE.
           SELECT KLISTE ASSIGN TO KLISTE.
      *
       DATA DIVISION.
       FILE SECTION.
       FD  SCHULE.
      *
       01  EB.
           02 EFN    PIC X(20).
           02 EVN    PIC X(10).
           02 EG     PIC A(1).
           02 EGD    PIC X(8).
           02 FILLER PIC X(5).
           02 EKL    PIC X(5).
           02 FILLER PIC X(31).
      *
       FD  KLISTE.
       01  DBER      PIC X(76).
      *
       WORKING-STORAGE SECTION.
       01  ABUE.
           02 FILLER PIC X(19)  VALUE "           1BKDV".
           02 FILLER PIC X(33)  VALUE "LFD.NUMMER  FAMILIENNAME".
           02 FILLER PIC X(24)  VALUE "VORNAME     GEBURTSDATUM".
      *
       01  AB.
           02 FILLER PIC X(23)  VALUE SPACE.
           02 ALNR   PIC 9(2).
           02 FILLER PIC X(6)   VALUE SPACE.
           02 AFN    PIC X(20).
           02 FILLER PIC X(1)   VALUE SPACE.
           02 AVN    PIC X(10).
           02 FILLER PIC X(4)   VALUE SPACE.
           02 AGD    PIC X(8).
           02 FILLER PIC X(2)   VALUE SPACE.
      *
       77  ZMAX      PIC 99     VALUE 20    COMP-3.
       77  ZZ        PIC 99                 COMP-3.
      *
      * ----------------
      * PARAMETER
      *
       77  VKL       PIC XXXXX  VALUE "1BKDV".
       77  VG        PIC X      VALUE "M".
      * ----------------
      *
       77  RLNR      PIC 99                 COMP-3.
      *
       77  EOF       PIC 9      VALUE 0.
      *
       PROCEDURE DIVISION.
       ANFANG.
           OPEN INPUT SCHULE OUTPUT KLISTE.
      *
           PERFORM UPSTART.
           READ SCHULE AT END MOVE 1 TO EOF.
           PERFORM WITH TEST BEFORE UNTIL EOF = 1
               IF EKL = VKL THEN
                   PERFORM UPVA
               END-IF
               READ SCHULE AT END MOVE 1 TO EOF
               END-READ
           END-PERFORM. 
      *
           CLOSE SCHULE KLISTE.
           STOP RUN.
      *
       UPSTART.
           COMPUTE ZZ = ZMAX.
           COMPUTE RLNR = 0.
       UPVA.
           PERFORM UPABER.
           PERFORM UPAUSGAB.
      *
       UPABER.
           COMPUTE RLNR = RLNR + 1.
           MOVE RLNR TO ALNR.
           MOVE EFN TO AFN.
           MOVE EVN TO AVN.
           IF EG = VG THEN
               MOVE EGD TO AGD
           ELSE
               MOVE SPACE TO AGD
           END-IF.
      *
       UPAUSGAB.
           PERFORM UPUEB.
           WRITE DBER FROM AB AFTER 1.
           COMPUTE ZZ = ZZ + 1.
      *
       UPUEB.
           IF ZZ NOT LESS ZMAX THEN
               PERFORM UPUEBER
           END-IF.
      *
       UPUEBER.
           WRITE DBER FROM ABUE AFTER PAGE.
           MOVE SPACE TO DBER.
           WRITE DBER AFTER 1.
           COMPUTE ZZ = 2.
