       IDENTIFICATION DIVISION.
       PROGRAM-ID. A17.
      *
      ****************************************************************
      * EINGABEDATEN: ZAHLENDATEI
      *      AUFBAU:
      *        1 - 10 (10) ... ZAHL X
      *       11 - 20 (10) ... ZAHL Y
      *       21 - 30 (10) ... ZAHL Z
      *---------------------------------------------------------------
      * AUSGABEDATEN: BLOCKLISTE
      *      AUFBAU:
      *        3 ZEILEN FR JEDEN DATENSATZ:
      *            1. ZEILE MIT
      *                X, Y, Z IN EINGABEREIHENFOLGE
      *                           SOWIE TEXT 'UNSORTIERT'
      *            2. ZEILE MIT
      *                X, Y, Z IN SORTIERTER REIHENFOLGE
      *                           SOWIE TEXT 'SORTIERT'
      *            1 LEERZEILE
      *
      * PRO SEITE MAXIMAL 66 ZEILEN.
      ****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT ZAHLEN ASSIGN TO ZAHLEN.
           SELECT ABLOCK ASSIGN TO ABLOCK.
      *
       DATA DIVISION.
       FILE SECTION.
      *
       FD  ZAHLEN.
       01  EBER.
           02 EX     PIC 9(10).
           02 EY     PIC 9(10).
           02 EZ     PIC 9(10).
      *
       FD  ABLOCK.
       01  DBER      PIC X(53).
      *
       WORKING-STORAGE SECTION.
       01  ABER.
           02 CC     PIC X      VALUE SPACE.
           02 AX     PIC Z(9)9.
           02 FILLER PIC X(4)   VALUE SPACE.
           02 AY     PIC Z(9)9.
           02 FILLER PIC X(4)   VALUE SPACE.
           02 AZ     PIC Z(9)9.
           02 FILLER PIC X(4)   VALUE SPACE.
           02 ATEXT  PIC X(10).
      *
       77  LIM       PIC 99     VALUE 22      COMP-3.
       77  BZ        PIC 99     VALUE 99      COMP-3.
      *
       77  TEXT1     PIC X(10)  VALUE "UNSORTIERT".
       77  TEXT2     PIC X(10)  VALUE "SORTIERT".
      *
       77  HILF      PIC 9(10).
       77  SCHTAUSCH PIC X.
       77  JA        PIC X      VALUE "J".
       77  NEIN      PIC X      VALUE "N".
      *
       77  SCH       PIC X.
       77  ZEIL1     PIC X      VALUE "1".
       77  ZEIL2     PIC X      VALUE "2".
      *
       77  EOF       PIC 9      VALUE 0.
      * 
       PROCEDURE DIVISION.
       ANFANG.
           OPEN INPUT  ZAHLEN
                OUTPUT ABLOCK.
      *
           MOVE ZEIL1 TO SCH.
           READ ZAHLEN AT END MOVE 1 TO EOF.
           PERFORM WITH TEST BEFORE UNTIL EOF = 1
               MOVE EX TO AX
               MOVE EY TO AY
               MOVE EZ TO AZ
               IF SCH = ZEIL1
               THEN MOVE TEXT1 TO ATEXT
                    IF BZ >= LIM
                    THEN MOVE SPACE TO DBER
                         WRITE DBER AFTER PAGE
                         COMPUTE BZ = 0
                    END-IF
                    WRITE DBER FROM ABER AFTER 1
                    MOVE ZEIL2 TO SCH
                    PERFORM UPSORT
               ELSE MOVE TEXT2 TO ATEXT
                    WRITE DBER FROM ABER AFTER 1
                    MOVE SPACE TO DBER
                    WRITE DBER AFTER 1
                    COMPUTE BZ = BZ + 1
                    MOVE ZEIL1 TO SCH
                    READ ZAHLEN AT END MOVE 1 TO EOF
                    END-READ
               END-IF
           END-PERFORM.
      *
           CLOSE ZAHLEN ABLOCK.
           STOP RUN.
      *
       UPSORT.
           MOVE JA TO SCHTAUSCH.
           PERFORM WITH TEST BEFORE UNTIL SCHTAUSCH NOT = JA
               MOVE NEIN TO SCHTAUSCH
               IF EX > EY THEN
                   PERFORM UPTAUSCHXY
                   MOVE JA TO SCHTAUSCH
               END-IF
               IF EY > EZ THEN
                   PERFORM UPTAUSCHYZ
                   MOVE JA TO SCHTAUSCH
               END-IF
           END-PERFORM.
      *
       UPTAUSCHXY.
           MOVE EX TO HILF.
           MOVE EY TO EX.
           MOVE HILF TO EY.
      *
       UPTAUSCHYZ.
           MOVE EY TO HILF.
           MOVE EZ TO EY.
           MOVE HILF TO EZ.
