       IDENTIFICATION DIVISION.
       PROGRAM-ID. A25.
      *
      ****************************************************************
      * EINGABEDATEN: SCHLERDATEI
      *      AUFBAU:
      *        1 - 20 (20) ... FAMILIENNAME
      *       21 - 30 (10) ... VORNAME
      *          31   ( 1) ... GESCHLECHT
      *       32 - 39 ( 8) ... GEBURTSDATUM (IN DER FORM JJJJMMTT)
      *       40 - 41 ( 2) ... RELIGION (VERSCHLSSELT)
      *       42 - 44 ( 3) ... STAATSBRGERSCHAFT
      *       45 - 49 ( 5) ... KLASSE
      *       50 - 53 ( 4) ... POSTLEITZAHL
      *       54 - 65 (12) ... ORT
      *       66 - 80 (15) ... STRASSE
      *
      * DIE DATENSTZE SIND AUFSTEIGEND SORTIERT NACH DER KLASSE.
      *---------------------------------------------------------------
      * AUSGABEDATEN: KLASSEZAHLEN
      *      AUFBAU:
      *        1 SPALTENBERSCHRIFT UND
      *        1 LEERZEILE
      *
      *        1 ZEILE FR JEDE KLASSE MIT
      *            KLASSE
      *            ANZAHL SCHLER DER KLASSE
      *
      *        1 LEERZEILE UND
      *        1 GESAMTSUMMENZEILE MIT
      *            GESAMTANZAHL ALLER SCHLER
      *
      * PRO SEITE MAXIMAL 60 ZEILEN
      *     (EINSCHL. BERSCHRIFT + LEERZEILE),
      *     AUSGENOMMEN DIE LETZTE SEITE.
      * DIE SUMMENZEILE SOLL NICHT UNMITTELBAR AUF DIE
      * BERSCHRIFT FOLGEN.
      ****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT SCHULE ASSIGN TO SCHULE.
           SELECT KLIST  ASSIGN TO KLIST.
      *
       DATA DIVISION.
       FILE SECTION.
      *
       FD  SCHULE.
       01  EB.
           02 FILLER PIC X(44).
           02 EKL    PIC X(5).
           02 FILLER PIC X(31).
      *
       FD  KLIST.
       01  DBER      PIC X(62).
      *
       WORKING-STORAGE SECTION.
       01  ABUE.
           02 FILLER PIC A(30)  VALUE SPACE.
           02 FILLER PIC A(20)  VALUE "KLASSE".
           02 FILLER PIC A(12)  VALUE "SCHUELERZAHL".
      *
       01  AB.
           02 FILLER PIC X(31)  VALUE SPACE.
           02 AKL    PIC X(5).
           02 FILLER PIC X(19)  VALUE SPACE.
           02 ASUM   PIC Z9.
           02 FILLER PIC X(5)   VALUE SPACE.
      *
       01  ABS.
           02 FILLER PIC A(20)  VALUE SPACE.
           02 FILLER PIC A(33)  VALUE "GESAMTANZAHL ALLER SCHUELER:".
           02 AGSUM  PIC ZZZ9.
           02 FILLER PIC X(5)   VALUE SPACE.
      *
       01  ABF.
           02 FILLER PIC A(24)  VALUE " SORTIERFOLGEFEHLER BEI".
           02 AFKL   PIC X(5).
           02 FILLER PIC X(33)  VALUE SPACE.
      *
       77  ZMAX      PIC 99     VALUE 60   COMP-3.
       77  ZZ        PIC 99                COMP-3.
      *
       77  VKL       PIC X(5).
       77  HIGH      PIC X(5)   VALUE HIGH-VALUE.
      *
       77  SUMM      PIC 99                COMP-3.
       77  GSUM      PIC 9999              COMP-3.
      *
       PROCEDURE DIVISION.
       ANFANG.
           OPEN INPUT  SCHULE
                OUTPUT KLIST.
      *
           PERFORM UPROGVOR.
           READ SCHULE AT END MOVE HIGH-VALUE TO EKL.
           PERFORM WITH TEST BEFORE UNTIL EKL = HIGH
               PERFORM UPGRVOR
               PERFORM WITH TEST BEFORE UNTIL EKL NOT = VKL
                   PERFORM UPEINZEL
                   READ SCHULE AT END MOVE HIGH-VALUE TO EKL
                   END-READ
               END-PERFORM
               PERFORM UPGRNACH
               PERFORM UPSORT
           END-PERFORM.
           PERFORM UPROGNACH.
      *
           CLOSE SCHULE KLIST.
           STOP RUN.
      *
       UPEINZEL.
           COMPUTE SUMM = SUMM + 1.
      *
       UPROGVOR.
           COMPUTE ZZ = ZMAX.
           COMPUTE GSUM = 0.
      *
       UPROGNACH.
           COMPUTE AGSUM = GSUM.
           WRITE DBER FROM ABS AFTER 2.
      *
       UPGRVOR.
           COMPUTE SUMM = 0.
           MOVE EKL TO AKL.
           MOVE EKL TO VKL.
      *
       UPGRNACH.
           MOVE SUMM TO ASUM.
           PERFORM UPUEB.
           WRITE DBER FROM AB AFTER 1.
           COMPUTE ZZ = ZZ + 1.
           COMPUTE GSUM = GSUM + SUMM.
      *
       UPSORT.
           IF EKL > VKL
           THEN CONTINUE
           ELSE MOVE EKL TO AFKL
                PERFORM UPUEB
                WRITE DBER FROM ABF AFTER 1
                COMPUTE ZZ = ZZ + 1
           END-IF.
      *
       UPUEB.
           IF ZZ NOT < ZMAX
           THEN WRITE DBER FROM ABUE AFTER PAGE
                MOVE SPACE TO DBER
                WRITE DBER AFTER 1
                COMPUTE ZZ = 2
           END-IF.
