       IDENTIFICATION DIVISION.
       PROGRAM-ID. A27.
      *
      ****************************************************************
      * EINGABEDATEN: KOSTENDATEI
      *      AUFBAU:
      *        1 -  2 (2) ... KOSTENSTELLENNUMMER
      *        3 -  4 (2) ... KOSTENARTENNUMMER
      *        5 - 12 (8) ... BETRAG (2 NACHKOMMASTELLEN)
      *
      * DIE EINGABEDATEN SIND NACH KOSTENSTELLEN UND INNERHALB DIESER
      * NACH KOSTENARTEN AUFSTEIGEND SORTIERT.
      * SORTIERFEHLER SIND NICHT AUSZUSCHLIESSEN.
      *---------------------------------------------------------------
      * AUSGABEDATEN: KOSTENBERSICHTSLISTE
      *      AUFBAU:
      *        1 SPALTENBERSCHRIFT
      *        1 LEERZEILE
      *
      *        1 ZEILE PRO KOSTENART MIT
      *            KOSTENART
      *            SUMME KOSTENART
      *
      *        1 ZEILE PRO KOSTENSTELLE MIT
      *            KOSTENSTELLE
      *            SUMME KOSTENSTELLE
      *            1 STERN
      *        DANACH 1 LEERZEILE
      *
      *        1 GESAMTSUMMENZEILE MIT
      *            GESAMTSUMME
      *            2 STERNE
      *
      * PRO SEITE MAXIMAL 60 ZEILEN
      *     (EINSCHL. BERSCHRIFT + LEERZEILE,
      *      AUSGENOMMEN EV. SUMMENZEILEN).
      * SUMMENZEILEN SOLLEN NIE UNMITTELBAR AUF DIE
      * BERSCHRIFT FOLGEN.
      ****************************************************************
      * BEI SORTIERFEHLER NUR SPRECHENDE FEHLERMELDUNG.
      ****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT KOSTEN ASSIGN TO KOSTEN.
           SELECT KLIST  ASSIGN TO KLIST.
      *
       DATA DIVISION.
       FILE SECTION.
      *
       FD  KOSTEN.
       01  EBER.
           02 EKST   PIC X(2).
           02 EKA    PIC X(2).
           02 EBET   PIC 9(6)V99.
      *
       FD  KLIST.
       01  DBER      PIC X(42).
      *
       WORKING-STORAGE SECTION.
      *------------------------------------------
       01  EL2.
           05  EL1.
               10  EL0.
                   15  EEOF  PIC X(1).
               10  EGST1     PIC X(2).
           05  EGST2         PIC X(2).
       01  VL2.
           05  VL1.
               10  VL0.
                   15  VEOF  PIC X(1).
               10  VGST1     PIC X(2).
           05  VGST2         PIC X(2).
      *------------------------------------------
       01  ABUE.
           02 FILLER PIC A(42) VALUE " KOSTENSTELLE  KOSTENART
      -    " SUMME".
      *
       01  ABL2.
           02 FILLER PIC X(6)   VALUE SPACE.
           02 AKSTL2 PIC X(2).
           02 FILLER PIC X(10)  VALUE SPACE.
           02 AKAL2  PIC X(2).
           02 FILLER PIC X(8)   VALUE SPACE.
           02 ASUML2 PIC Z,ZZZ,ZZ9.99.
           02 FILLER PIC X(2)   VALUE SPACE.
      *
       01  ABL1.
           02 FILLER PIC X(6)   VALUE SPACE.
           02 AKSTL1 PIC X(2).
           02 FILLER PIC X(18)  VALUE SPACE.
           02 ASUML1 PIC ZZZ,ZZZ,ZZ9.99.
           02 FILLER PIC X(2)   VALUE "* ".
      *
       01  ABL0.
           02 FILLER PIC X(23)  VALUE SPACE.
           02 ASUML0 PIC ZZ,ZZZ,ZZZ,ZZ9.99.
           02 FILLER PIC X(2)   VALUE "**".
      *
       01  ABF.
           02 FILLER PIC A(42)  VALUE " SORTIERFOLGEFEHLER".
      *
       77  ZMAX      PIC 99     VALUE 60  COMP-3.
       77  ZZ        PIC 99               COMP-3.
      *
       77  SUML2     PIC 9(7)V99          COMP-3.
       77  SUML1     PIC 9(9)V99          COMP-3.
       77  SUML0     PIC 9(11)V99         COMP-3.
      *
       PROCEDURE DIVISION.
       ANFANG.
           OPEN INPUT  KOSTEN
                OUTPUT KLIST.
      *
           PERFORM UPLES.
           PERFORM UPROGVOR.
           PERFORM WITH TEST BEFORE UNTIL EL0 NOT = VL0
               PERFORM UPHGVOR
               PERFORM WITH TEST BEFORE UNTIL EL1 NOT = VL1
                   PERFORM UPGRVOR
                   PERFORM WITH TEST BEFORE UNTIL EL2 NOT = VL2
                       PERFORM UPEINZEL
                       PERFORM UPLES
                   END-PERFORM
                   PERFORM UPGRNACH
               END-PERFORM
               PERFORM UPHGNACH
           END-PERFORM.
           PERFORM UPROGNACH.
      *
           CLOSE KOSTEN KLIST.
           STOP RUN.
      *
       UPLES.
           READ KOSTEN
               AT END MOVE HIGH-VALUE TO EEOF
               NOT AT END MOVE EKST TO EGST1
                          MOVE EKA TO EGST2
           END-READ.
      *
       UPEINZEL.
           COMPUTE SUML2 = SUML2 + EBET.
      *
       UPROGVOR.
           MOVE LOW-VALUE TO EEOF.
           COMPUTE ZZ = ZMAX.
           COMPUTE SUML0 = 0.
           MOVE EEOF TO VEOF.
      *
       UPROGNACH.
           MOVE SUML0 TO ASUML0.
           WRITE DBER FROM ABL0 AFTER 1.
      *
       UPHGVOR.
           COMPUTE SUML1 = 0.
           MOVE EKST TO AKSTL2.
           MOVE EKST TO AKSTL1.
           MOVE EGST1 TO VGST1.
      *
       UPHGNACH.
           MOVE SUML1 TO ASUML1.
           WRITE DBER FROM ABL1 AFTER 1.
           MOVE SPACE TO DBER.
           WRITE DBER AFTER 1.
           COMPUTE ZZ = ZZ + 2.
           COMPUTE SUML0 = SUML0 + SUML1.
      *
       UPGRVOR.
           COMPUTE SUML2 = 0.
           MOVE EKA TO AKAL2.
           MOVE EGST2 TO VGST2.
      *
       UPGRNACH.
           MOVE SUML2 TO ASUML2.
           PERFORM UPUEB.
           WRITE DBER FROM ABL2 AFTER 1.
           COMPUTE ZZ = ZZ + 1.
           MOVE SPACE TO ABL2.
           COMPUTE SUML1 = SUML1 + SUML2.
           PERFORM UPSORT.
      *
       UPUEB.
           IF ZZ NOT < ZMAX
           THEN WRITE DBER FROM ABUE AFTER PAGE
                MOVE SPACE TO DBER
                WRITE DBER AFTER 1
                COMPUTE ZZ = 2
                MOVE VGST1 TO AKSTL2
           END-IF.
      *
       UPSORT.
           IF EL2 > VL2
           THEN CONTINUE
           ELSE PERFORM UPUEB
                WRITE DBER FROM ABF AFTER 1
                COMPUTE ZZ = ZZ + 1
           END-IF.
