       IDENTIFICATION DIVISION.
       PROGRAM-ID. A39.
      *
      ****************************************************************
      * EINGABEDATEN: ARTIKELDATEI
      *      AUFBAU:
      *        1 -  4 ( 4) ... ARTIKELNUMMER
      *        5 - 24 (20) ... ARTIKELBEZEICHNUNG
      *       25 - 31 ( 7) ... EINZELPREIS
      *       32 - 36 ( 5) ... BESTANDSMENGE
      *       37 - 55 (19) ... SONSTIGE DATEN
      *
      * EINGABEDATEN: NDERUNGSDATEI
      *      AUFBAU:
      *        1 -  4 ( 4) ... ARTIKELNUMMER
      *        5 - 11 ( 7) ... NEUER EINZELPREIS
      *
      * BEIDE DATEIEN SIND AUFSTEIGEND SORTIERT NACH DER
      * ARTIKELNUMMER.
      * PRO ARTIKELNUMMER GIBT ES NUR 1 EINGABEDATENSATZ.
      *---------------------------------------------------------------
      * AUSGABEDATEN: AKTUALISIERTE ARTIKELDATEI
      *
      *               FEHLERPROTOKOLL
      *                     ZU NDERNDE ARTIKELNUMMER NICHT VORHANDEN
      *                     SORTIERFOLGEFEHLER IN DER NDERUNGSDATEI
      ****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT ALTBAND ASSIGN TO ALTBAND.
           SELECT KAENDER ASSIGN TO KAENDER.
           SELECT NEUBAND ASSIGN TO NEUBAND.
           SELECT FEHLER  ASSIGN TO FEHLER.
      *
       DATA DIVISION.
       FILE SECTION.
      *
       FD  ALTBAND.
       01  BBER.
           02 BNR     PIC X(4).
           02 FILLER  PIC X(20).
           02 BPREIS  PIC 9(7).
           02 FILLER  PIC X(24).
      *
       FD  KAENDER.
       01  KBER.
           02 KNR     PIC X(4).
           02 KPREIS  PIC 9(7).
      *
       FD  NEUBAND.
       01  BBERNEU    PIC X(55).
      *
       FD  FEHLER.
       01  DBER       PIC X(36).
      *
       WORKING-STORAGE SECTION.
       77  FUEB       PIC X(36)  VALUE " FEHLERPROTOKOLL".
      *
       01  FBER.
           02 CC      PIC X      VALUE SPACE.
           02 FNR     PIC X(4).
           02 FILLER  PIC X(1)   VALUE SPACE.
           02 FMELD   PIC X(30).
      *
       77  ZZGF       PIC 99     VALUE 66   COMP-3.
       77  ZZF        PIC 99     VALUE 99   COMP-3.
      *
       77  FEHL1      PIC X(30)  VALUE "ARTIKEL NICHT VORHANDEN".
      *
       77  EOFZ       PIC 9                 COMP-3.
      *
       PROCEDURE DIVISION.
       ANFANG.
           OPEN INPUT  ALTBAND, KAENDER
                OUTPUT NEUBAND, FEHLER.
      *
           COMPUTE EOFZ = 0.
           PERFORM UPLESALTBAND.
           PERFORM UPLESKAENDER.
           PERFORM WITH TEST BEFORE UNTIL EOFZ >= 2
               IF BNR < KNR
               THEN WRITE BBERNEU FROM BBER
                    PERFORM UPLESALTBAND
               ELSE IF BNR = KNR
                    THEN MOVE KPREIS TO BPREIS
                         WRITE BBERNEU FROM BBER
                         PERFORM UPLESALTBAND
                         PERFORM UPLESKAENDER
                    ELSE MOVE FEHL1 TO FMELD
                         PERFORM UPSCHRF
                         PERFORM UPLESKAENDER
                    END-IF
               END-IF
           END-PERFORM.
      *
           CLOSE ALTBAND, KAENDER,
                 NEUBAND, FEHLER.
           STOP RUN.
      * ----------------------------------
       UPLESALTBAND.
           READ ALTBAND
               AT END MOVE HIGH-VALUE TO BNR
                      COMPUTE EOFZ = EOFZ + 1
           END-READ.
      * ----------------------------------
       UPLESKAENDER.
           READ KAENDER
               AT END MOVE HIGH-VALUE TO KNR
                      COMPUTE EOFZ = EOFZ + 1
           END-READ.
      * ----------------------------------
       UPSCHRF.
           MOVE KNR TO FNR.
           IF ZZF NOT LESS ZZGF THEN
               WRITE DBER FROM FUEB AFTER PAGE
               MOVE SPACE TO DBER
               WRITE DBER AFTER 1
               COMPUTE ZZF = 2
           END-IF.
           WRITE DBER FROM FBER AFTER 1.
           COMPUTE ZZF = ZZF + 1.
