/* bung A04
   Autor: Beringer Alfred
   Vertreterliste - berschrift, Rechenfelder, Datentypen, lfd. Nr., Satzzhler.
 ---------------------------------------------------------------
  EINGABEDATEN: VERTRETERUMSATZDATEI
       AUFBAU:
         1 -  6 ( 6) ... VERTRETERNUMMER
         7 - 35 (29) ... VERTRETERNAME
        36 - 46 (11) ... VERTRETERUMSATZ (2 NACHKOMMASTELLEN)
 ---------------------------------------------------------------
  AUSGABEDATEN: VERTRETERUMSATZLISTE
       AUFBAU:
         1 SPALTENBERSCHRIFT UND
         1 LEERZEILE
 
         1 ZEILE PRO VERTRETER MIT
             LAUFENDER NUMMER
             VERTRETERNAME
             VERTRETERUMSATZ
             VERTRETERNUMMER
 
  PRO SEITE MAXIMAL 22 ZEILEN (EINSCHL. BERSCHRIFT + LEERZEILE).
  DIE BERSCHRIFT SOLL NIE ALLEIN AUF EINER SEITE STEHEN.
 ---------------------------------------------------------------
*/

#include <conio.h>
#include <stdio.h>
#include <string.h>

/* Bei Verwendung eines MS-Compilers muss man die Funktion clrscr() selbst
   definieren und ins Programm (bzw. ins Projekt) einfgen:
*/
#include "..\\Headerdateien\\clrscr.h"

/* Die Strukturdeklaration fr den Eingabebereich befindet sich in einer
   Header-Datei und wird durch den nachfolgenden include-Befehl in das
   Programm eingefgt:
*/
#include "..\\Headerdateien\\vertret-EIN.h"

/* Die tatschlich verwendete Datei wird im open-Befehl festgelegt.
   Um den Dateinamen und/oder den Pfad einfach ndern zu knnnen, wird der
   folgende Parameter EINGABEDATEI definiert:
*/
#define EINGABEDATEI  "..\\Dateien\\vertreter.datC"

/* Der nachfolgende Makrobefehl NEUESEITE stoppt den Programmablauf und
   wartet auf eine Benutzereingabe - dies bewirkt die Funktion _getch().
   Der Benutzer hat somit die Mglichkeit, in Ruhe die Bildschirmseite zu
   betrachten und danach durch Drcken einer beliebigen Taste das Programm
   fortzusetzen. Es ist sinnvoll, dies dem Benutzer vorher mitzuteilen.
   Diese Mitteilung wird nach einer Leerzeile (der bersichtlichkeit halber)
   in die letzte Zeile (im Allg. ist dies die 24.) geschrieben, sodass die
   restliche Bildschirmseite noch 22 Zeilen hat.
*/
#define NEUESEITE  printf("\nWeiter mit beliebiger Taste"); _getch(); clrscr()

/* Der nachfolgende Makrobefehl LEERZEILE besteht nur aus 1 Befehl:
*/
#define LEERZEILE  printf("\n")

#define ZZG    22

#define UEB    "LFDE.NR.  V E R T R E T E R N A M E     VERTRETERUMSATZ  NUMMER\n"
#define F_AUS  " %6ld   %s % 13.2f    %s\n"

struct AUS
{
  long int alf;
  char     anam[29+1];
  float    aums;
  char     anr [ 6+1];
};

void main()
{
  FILE *VERTRET;
  //    VLISTE = Standardausgabe stdout

  const short int K0 = 0,
                  K1 = 1,
                  K2 = 2;
  EIN ein;
  AUS aus;

  long  int rlf = 0;
  short int zz;

  /* --------------------------------- */
  VERTRET = fopen(EINGABEDATEI,"rb");

  zz = ZZG;
  rlf = K0;
  fread(&ein,sizeof(ein),1,VERTRET);
  while (!feof(VERTRET))
  {
    rlf = rlf + K1;
    aus.alf = rlf;
    strcpy(aus.anam,ein.enam);
    aus.aums = ein.eums;
    strcpy(aus.anr,ein.enr);
    if (zz >= ZZG)
    {
      NEUESEITE;
      printf(UEB);
      LEERZEILE;
      zz = K2;
    }
    printf(F_AUS, aus.alf, aus.anam, aus.aums, aus.anr);
    zz = zz + K1;
    fread(&ein,sizeof(ein),1,VERTRET);
  }

  fclose(VERTRET);
  /* --------------------------------- */

  /* Durch die nachfolgende getch-Funktion wird das Konsolen-Fenster nicht sofort
     geschlossen - das Programm wartet noch auf eine abschlieende Benutzereingabe.
     Damit kann auch die letzte Bildschirmseite in Ruhe betrachtet werden.
  */
  _getch();
} /* ----- Ende main */
