/* bung A12
   Autor: Beringer Alfred
   Kundenstatistik - Inland/Ausland, Soll/Haben,
                     Fehlerprfungen.
 ---------------------------------------------------------------
  EINGABEDATEN: KUNDENDATEI
       AUFBAU:
         1 -  4 ( 4) ... KUNDENNUMMER
         5 - 24 (20) ... KUNDENNAME
           25   ( 1) ... SCHLSSEL ('1' = SOLL,
                                    '2' = HABEN)
        26 - 33 ( 8) ... UMSATZ (2 NACHKOMMASTELLEN)
           34   ( 1) ... SATZART ('1' = INLANDSUMSATZ,
                                  '2' = AUSLANDSUMSATZ)
 
  DIE EINGABEDATEN SIND NACH KUNDENNUMMERN AUFSTEIGEND SORTIERT.
  PRO SCHLSSEL UND SATZART GIBT ES MAXIMAL 100 DATENSTZE.
 ---------------------------------------------------------------
  AUSGABEDATEN: UMSATZLISTE
       AUFBAU:
         1 HAUPTBERSCHRIFT
         1 SPALTENBERSCHRIFT
         1 LEERZEILE
 
         1 ZEILE FR JEDEN KUNDEN MIT
             KUNDENNAME
             UMSATZ - IN ENTSPRECHENDER SPALTE
                         (JE NACH SATZART UND SCHLSSEL)
 
        AM ENDE DER VERARBEITUNG:
         1 LEERZEILE UND
         1 GESAMTSUMMENZEILE MIT DEN 4 SPALTENSUMMEN
 
  PRO SEITE MAXIMAL 22 ZEILEN
      (EINSCHL. BERSCHRIFTEN + LEERZEILEN),
      AUSGENOMMEN DIE LETZTE SEITE).
  DIE SUMMENZEILE SOLL NIE UNMITTELBAR AUF DIE 
      BERSCHRIFT FOLGEN.
 ---------------------------------------------------------------
*/

#include <conio.h>
#include <stdio.h>
#include <string.h>
#include "..\\Headerdateien\\clrscr.h"
#include "..\\Headerdateien\\makros.h"

#include "..\\Headerdateien\\kunden-EBER.h"

#define EINGABEDATEI  "..\\Dateien\\kunden.datC"

#define ZMAX   22
#define LOW    "\x00\x00\x00\x00"
#define VSOL   '1'
#define VHAB   '2'
#define VILD   '1'
#define VALD   '2'

#define ABU1   "K U N D E N N A M E          I N L A N D            A U S L A N D   \n"
#define ABU2   "                           SOLL       HABEN        SOLL       HABEN \n"
#define F_ABER "%s  % 10.2f  % 10.2f  % 10.2f  % 10.2f\n"
#define F_ABS  "                    % 12.2f% 12.2f% 12.2f% 12.2f\n"
#define F_KFEL "%s %s\n"

#define FM1    "SORTIERFOLGEFEHLER"
#define FM2    "FALSCHER SCHLUESSEL"
#define FM3    "FALSCHE SATZART   "

struct ABER
{
  char  anam[20+1];
  float aisol,
        aihab,
        aasol,
        aahab;
};

struct ABS
{
  float asumis,
        asumih,
        asumas,
        asumah;
};

struct KFEL
{
  char knr[ 4+1],
       kfm[19+1];
};

void upstart(char nralt[],
             short int &zz,
             float &sumis,
             float &sumih,
             float &sumas,
             float &sumah);
void upendva(float sumis,
             float sumih,
             float sumas,
             float sumah);
void upschr (EBER eber,
             ABER aber,
             short int &zz);
void upueber(short int &zz);
void upfel  (EBER eber,
             KFEL kfel,
             short int &zz);

void main()
{
  FILE *KUNDEN;
  /*    UMSATZ  und
        KONSOLE = Standardausgabe stdout */

  EBER  eber;
  ABER  aber;
  KFEL  kfel;
  char  nralt[4+1];
  float sumis,
        sumih,
        sumas,
        sumah;
  short int zz;

  KUNDEN = fopen(EINGABEDATEI,"rb");

  upstart(nralt,zz,sumis,sumih,sumas,sumah);
  fread(&eber,sizeof(eber),1,KUNDEN);
  while (!feof(KUNDEN))
  {
    if (strcmp(nralt,eber.enr) >= 0)
    {
      strcpy(kfel.kfm,FM1);
      upfel(eber,kfel,zz);
    }
    else
      strcpy(nralt,eber.enr);
    aber.aisol = 0.0f;
    aber.aihab = 0.0f;
    aber.aasol = 0.0f;
    aber.aahab = 0.0f;
    if (eber.eschl == VSOL)
      if (eber.esa == VILD)
      {
        aber.aisol = eber.eums;
        sumis = sumis + eber.eums;
        upschr(eber,aber,zz);
      }
      else
        if (eber.esa == VALD)
        {
          aber.aasol = eber.eums;
          sumas = sumas + eber.eums;
          upschr(eber,aber,zz);
        }
        else
        {
          strcpy(kfel.kfm,FM3);
          upfel(eber,kfel,zz);
        }
    else
      if (eber.eschl == VHAB)
        if (eber.esa == VILD)
        {
          aber.aihab = eber.eums;
          sumih = sumih + eber.eums;
          upschr(eber,aber,zz);
        }
        else
          if (eber.esa == VALD)
          {
            aber.aahab = eber.eums;
            sumah = sumah + eber.eums;
            upschr(eber,aber,zz);
          }
          else
          {
            strcpy(kfel.kfm,FM3);
            upfel(eber,kfel,zz);
          }
      else
      {
        strcpy(kfel.kfm,FM2);
        upfel(eber,kfel,zz);
        if (eber.esa == VILD) ;
        else
          if (eber.esa == VALD) ;
          else
          {
            strcpy(kfel.kfm,FM3);
            upfel(eber,kfel,zz);
          }
      }
    fread(&eber,sizeof(eber),1,KUNDEN);
  }
  upendva(sumis,sumih,sumas,sumah);

  fclose(KUNDEN);

  _getch();
} /* ----- Ende main */

void upstart(char nralt[],
             short int &zz,
             float &sumis,
             float &sumih,
             float &sumas,
             float &sumah)
{
  zz = ZMAX;
  strcpy(nralt,LOW);
  sumis = 0.0f;
  sumih = 0.0f;
  sumas = 0.0f;
  sumah = 0.0f;
} /* ----- Ende upstart */

void upendva(float sumis,
             float sumih,
             float sumas,
             float sumah)
{
  ABS abs;

  LEERZEILE;
  abs.asumis = sumis;
  abs.asumih = sumih;
  abs.asumas = sumas;
  abs.asumah = sumah;
  printf(F_ABS,abs.asumis,abs.asumih,abs.asumas,abs.asumah);
} /* ----- Ende upendva */

void upschr(EBER eber,
            ABER aber,
            short int &zz)
{
  strcpy(aber.anam,eber.enam);
  if (zz >= ZMAX)
    upueber(zz);
  printf(F_ABER,aber.anam,aber.aisol,aber.aihab,aber.aasol,aber.aahab);
  zz++;
} /* ----- Ende upschr */

void upueber(short int &zz)
{
  NEUESEITE;
  printf(ABU1);
  printf(ABU2);
  LEERZEILE;
  zz = 3;
} /* ----- Ende upueber */

void upfel(EBER eber,
           KFEL kfel,
           short int &zz)
{
  strcpy(kfel.knr,eber.enr);
  printf(F_KFEL,kfel.knr,kfel.kfm);
  zz++;
} /* ----- Ende upfel */
