/* bung A27
   Autor: Beringer Alfred
   Kostenstellen/Kostenarten - zweifacher Gruppenwechsel.
 ---------------------------------------------------------------
  EINGABEDATEN: KOSTENDATEI
       AUFBAU:
         1 -  2 ( 2) ... KOSTENSTELLENNUMMER
         3 -  4 ( 2) ... KOSTENARTENNUMMER
         5 - 12 ( 8) ... BETRAG (2 NACHKOMMASTELLEN)
 
  DIE EINGABEDATEN SIND NACH KOSTENSTELLEN UND INNERHALB DIESER
  NACH KOSTENARTEN AUFSTEIGEND SORTIERT.
  SORTIERFEHLER SIND NICHT AUSZUSCHLIESSEN.
 ---------------------------------------------------------------
  AUSGABEDATEN: KOSTENBERSICHTSLISTE
       AUFBAU:
         1 SPALTENBERSCHRIFT
         1 LEERZEILE
 
         1 ZEILE PRO KOSTENART MIT
             KOSTENART
             SUMME KOSTENART
 
         1 ZEILE PRO KOSTENSTELLE MIT
             KOSTENSTELLE
             SUMME KOSTENSTELLE
             1 STERN
         DANACH 1 LEERZEILE
 
         1 GESAMTSUMMENZEILE MIT
             GESAMTSUMME
             2 STERNE
 
  PRO SEITE MAXIMAL 20 ZEILEN
      (EINSCHL. BERSCHRIFT + LEERZEILE,
       AUSGENOMMEN EV. SUMMENZEILEN).
  SUMMENZEILEN SOLLEN NIE UNMITTELBAR AUF DIE
  BERSCHRIFT FOLGEN.
 ---------------------------------------------------------------
  BEI SORTIERFEHLER NUR SPRECHENDE FEHLERMELDUNG.
 ---------------------------------------------------------------
*/

#include <conio.h>
#include <stdio.h>
#include <string.h>
#include "..\\Headerdateien\\clrscr.h"
#include "..\\Headerdateien\\makros.h"

#include "..\\Headerdateien\\kosten-EB.h"

#define EINGABEDATEI  "..\\Dateien\\kosten.datC"

#define ZMAX   20
#define HIGH   '\xff'
#define LOW    '\x00'

#define L0LEN  1
#define L1LEN  4
#define L2LEN  7

#define ABUE   "KOSTENSTELLE  KOSTENART        SUMME  \n"
#define F_ABL2 "     %s          %s       % 10.2f  \n"
#define F_ABL1 "     %s                 % 12.2f* \n"
#define F_ABL0 "                      % 14.2f**\n"
#define ABF    "SORTIERFOLGEFEHLER \n"

struct L
{
  char eof,
       gst1[2+1],
       gst2[2+1];
};

struct ABL2
{
  char  akstl2[2+1],
        akal2 [2+1];
  float asuml2;
};

struct ABL1
{
  char  akstl1[2+1];
  float asuml1;
};

struct ABL0
{
  float asuml0;
};

static FILE *KOSTEN;
//           KLIST = Standardausgabe stdout

void uples    (EB &eb,
               L  &el);
void uprogvor (L &el,
               L &vl,
               float &suml0,
               short int &zz);
void uphgvor  (EB eb,
               L  el,
               L  &vl,
               ABL1 &abl1,
               ABL2 &abl2,
               float &suml1);
void upgrvor  (EB eb,
               L  el,
               L  &vl,
               ABL2 &abl2,
               float &suml2);
void upeinzel (EB eb,
               float &suml2);
void upgrnach (ABL2 &abl2,
               float suml2,
               float &suml1,
               short int &zz,
               L el,
               L vl);
void uphgnach (ABL1 &abl1,
               float suml1,
               float &suml0,
               short int &zz);
void uprognach(ABL0 &abl0,
               float suml0);
void upsort   (L el,
               L vl,
               ABL2 &abl2,
               short int &zz);
void upueb    (short int &zz,
               ABL2 &abl2,
               L vl);

void main()
{
  EB    eb;
  L     el,
        vl;
  ABL2  abl2;
  ABL1  abl1;
  ABL0  abl0;

  float suml0,
        suml1,
        suml2;
  short int zz;

  KOSTEN = fopen(EINGABEDATEI,"rb");

  uprogvor(el,vl,suml0,zz);
  uples(eb,el);
  while (memcmp(&el,&vl,L0LEN) == 0)
  {
    uphgvor(eb,el,vl,abl1,abl2,suml1);
    while (memcmp(&el,&vl,L1LEN) == 0)
    {
      upgrvor(eb,el,vl,abl2,suml2);
      while (memcmp(&el,&vl,L2LEN) == 0)
      {
        upeinzel(eb,suml2);
        uples(eb,el);
      }
      upgrnach(abl2,suml2,suml1,zz,el,vl);
    }
    uphgnach(abl1,suml1,suml0,zz);
  }
  uprognach(abl0,suml0);

  fclose(KOSTEN);

  _getch();
} /* ----- Ende main */

void uples(EB &eb,
           L  &el)
{
  fread(&eb,sizeof(eb),1,KOSTEN);
  if (feof(KOSTEN))
    el.eof = HIGH;
  else
  {
    strcpy(el.gst1,eb.ekst);
    strcpy(el.gst2,eb.eka);
  }
} /* ----- Ende uples */

void uprogvor(L &el,
              L &vl,
              float &suml0,
              short int &zz)
{
  el.eof = LOW;
  zz = ZMAX;
  suml0 = 0.0f;
  vl.eof = el.eof;
} /* ----- Ende uprogvor */

void uphgvor(EB eb,
             L  el,
             L  &vl,
             ABL1 &abl1,
             ABL2 &abl2,
             float &suml1)
{
  suml1 = 0.0f;
  strcpy(abl1.akstl1,eb.ekst);
  strcpy(abl2.akstl2,eb.ekst);
  strcpy(vl.gst1,el.gst1);
} /* ----- Ende uphgvor */

void upgrvor(EB eb,
             L  el,
             L  &vl,
             ABL2 &abl2,
             float &suml2)
{
  suml2 = 0.0f;
  strcpy(abl2.akal2,eb.eka);
  strcpy(vl.gst2,el.gst2);
} /* ----- Ende upgrvor */

void upeinzel(EB eb,
              float &suml2)
{
  suml2 = suml2 + eb.ebet;
} /* ----- Ende upeinzel */

void upgrnach(ABL2 &abl2,
              float suml2,
              float &suml1,
              short int &zz,
              L el,
              L vl)
{
  abl2.asuml2 = suml2;
  upueb(zz,abl2,vl);
  printf(F_ABL2,abl2.akstl2,abl2.akal2,abl2.asuml2);
  zz++;
  memset(abl2.akstl2,' ',strlen(abl2.akstl2));
  suml1 = suml1 + suml2;
  upsort(el,vl,abl2,zz);
} /* ----- Ende upgrnach */

void uphgnach(ABL1 &abl1,
              float suml1,
              float &suml0,
              short int &zz)
{
  abl1.asuml1 = suml1;
  printf(F_ABL1,abl1.akstl1,abl1.asuml1);
  LEERZEILE;
  zz = zz + 2;
  suml0 = suml0 + suml1;
} /* ----- Ende uphgnach */

void uprognach(ABL0 &abl0,
               float suml0)
{
  abl0.asuml0 = suml0;
  printf(F_ABL0,abl0.asuml0);
} /* ----- Ende uprognach */

void upsort(L el,
            L vl,
            ABL2 &abl2,
            short int &zz)
{
  if (memcmp(&el,&vl,sizeof(struct L)) < 0)
  {
    upueb(zz,abl2,vl);
    printf(ABF);
    zz++;
  }
} /* ----- Ende upsort */

void upueb(short int &zz,
           ABL2 &abl2,
           L vl)
{
  if (zz >= ZMAX)
  {
    NEUESEITE;
    printf(ABUE);
    LEERZEILE;
    zz = 2;
    strcpy(abl2.akstl2,vl.gst1);
  }
} /* ----- Ende upueb */
