/* bung A28
   Autor: Beringer Alfred
   Steueraufkommen - dreifacher Gruppenwechsel.
 ---------------------------------------------------------------
  EINGABEDATEN: STEUERDATEI
       AUFBAU:
           1    ( 1) ... BUNDESLANDSCHLSSEL ('1' - '9')
         2 -  3 ( 2) ... BEZIRKSCHLSSEL
         4 - 23 (20) ... GEMEINDENAME
        24 - 27 ( 4) ... GEMEINDEKENNZAHL (NICHT POSTLEITZAHL!)
        28 - 37 (10) ... STEUERAUFKOMMEN EINER PERSON (2 NACHKOMMAST.)
 
  DIE EINGABEDATEN SIND NACH BUNDESLNDERN, INNERHALB DIESER NACH
  BEZIRKEN UND INNERHALB DIESER NACH GEMEINDEN (GEMEINDEKENNZAHL)
  AUFSTEIGEND SORTIERT.
  DIE SORTIERFOLGE IST ZU PRFEN.
 ---------------------------------------------------------------
  AUSGABEDATEN: STEUERLISTE
       AUFBAU:
         1 SPALTENBERSCHRIFT
         1 LEERZEILE
 
         1 ZEILE PRO GEMEINDE MIT
             BUNDESLAND
             BEZIRK
             GEMEINDE
             SUMME STEUERAUFKOMMEN ALLER PERSONEN DIESER GEMEINDE
             
             BUNDESLAND UND BEZIRK NUR AM BEGINN DER GRUPPE UND
                                       AM BEGINN JEDER SEITE.
 
         1 ZEILE PRO BEZIRK MIT
             SUMME BEZIRK
             1 STERN
 
         1 ZEILE PRO BUNDESLAND MIT
             SUMME BUNDESLAND
             2 STERNE
 
         1 GESAMTSUMMENZEILE MIT
             GESAMTSUMME (STERREICHSUMME)
             3 STERNE
 
  PRO SEITE MAXIMAL 20 ZEILEN
      (EINSCHL. BERSCHRIFT + LEERZEILE,
       AUSGENOMMEN EV. SUMMENZEILEN).
  SUMMENZEILEN SOLLEN NIE UNMITTELBAR AUF DIE
  BERSCHRIFT FOLGEN.
 ---------------------------------------------------------------
*/

#include <conio.h>
#include <stdio.h>
#include <string.h>
#include "..\\Headerdateien\\clrscr.h"
#include "..\\Headerdateien\\makros.h"

#include "..\\Headerdateien\\steuer-EB.h"

#define EINGABEDATEI  "..\\Dateien\\steuer.datC"

#define ZMAX    20
#define HIGH    '\xff'
#define LOW     '\x00'

#define L0LEN    1
#define L1LEN    2
#define L2LEN    5
#define L3LEN   10

#define ABUE    "BUNDESLAND  BEZIRK  GEMEINDE       STEUERAUFKOMMEN     \n"
#define F_ABL3  "    %c         %s      %s            % 12.2f    \n"
#define F_ABL2  "                                  % 16.2f *  \n"
#define F_ABL1  "                                % 18.2f ** \n"
#define F_ABL0  "                               % 19.2f ***\n"
#define ABF     "SORTIERFOLGEFEHLER \n"

static EB eb;

static struct L
{
  char eof,
       gst1,
       gst2[2+1],
       gst3[4+1];
} el,vl;

static struct ABL3
{
  char  abll3,
        abezl3[2+1],
        ageml3[4+1];
  float asuml3;
} abl3;

static struct ABL2
{
  float asuml2;
} abl2;

static struct ABL1
{
  float asuml1;
} abl1;

static struct ABL0
{
  float asuml0;
} abl0;

static float suml0,
             suml1,
             suml2,
             suml3;
static short int zz;

static FILE *STEUER;
//           STLIS = Standardausgabe stdout

void uprogvor();
void uples();
void uphgvor();
void upgrvor();
void upugvor();
void upeinzel();
void upugnach();
void upgrnach();
void uphgnach();
void uprognach();
void upueb();

void main()
{
  STEUER = fopen(EINGABEDATEI,"rb");

  uprogvor();
  uples();
  while (memcmp(&el,&vl,L0LEN) == 0)
  {
    uphgvor();
    while (memcmp(&el,&vl,L1LEN) == 0)
    {
      upgrvor();
      while (memcmp(&el,&vl,L2LEN) == 0)
      {
        upugvor();
        while (memcmp(&el,&vl,L3LEN) == 0)
        {
          upeinzel();
          uples();
        }
        upugnach();
      }
      upgrnach();
    }
    uphgnach();
  }
  uprognach();

  fclose(STEUER);

  _getch();
} /* ----- Ende main */

void uples()
{
  fread(&eb,sizeof(eb),1,STEUER);
  if (feof(STEUER))
    el.eof = HIGH;
  else
  {
    el.gst1 = eb.ebl;
    strcpy(el.gst2,eb.ebez);
    strcpy(el.gst3,eb.egem);
  }
} /* ----- Ende uples */

void uprogvor()
{
  el.eof = LOW;
  zz = ZMAX;
  suml0 = 0.0f;
  vl.eof = el.eof;
} /* ----- Ende uprogvor */

void uphgvor()
{
  suml1 = 0.0f;
  abl3.abll3 = eb.ebl;
  vl.gst1 = el.gst1;
} /* ----- Ende uphgvor */

void upgrvor()
{
  suml2 = 0.0f;
  strcpy(abl3.abezl3,eb.ebez);
  strcpy(vl.gst2,el.gst2);
} /* ----- Ende upgrvor */

void upugvor()
{
  suml3 = 0.0f;
  strcpy(abl3.ageml3,eb.egem);
  strcpy(vl.gst3,el.gst3);
} /* ----- Ende upugvor */

void upeinzel()
{
  suml3 = suml3 + eb.esta;
} /* ----- Ende upeinzel */

void upugnach()
{
  abl3.asuml3 = suml3;
  upueb();
  printf(F_ABL3,abl3.abll3,abl3.abezl3,abl3.ageml3,abl3.asuml3);
  zz++;
  abl3.abll3 = ' ';
  memset(abl3.abezl3,' ',strlen(abl3.abezl3));
  memset(abl3.ageml3,' ',strlen(abl3.ageml3));
  suml2 = suml2 + suml3;
} /* ----- Ende upugnach */

void upgrnach()
{
  abl2.asuml2 = suml2;
  printf(F_ABL2,abl2.asuml2);
  LEERZEILE;
  zz = zz + 2;
  suml1 = suml1 + suml2;
} /* ----- Ende upgrnach */

void uphgnach()
{
  abl1.asuml1 = suml1;
  printf(F_ABL1,abl1.asuml1);
  LEERZEILE;
  zz = zz + 2;
  suml0 = suml0 + suml1;
} /* ----- Ende uphgnach */

void uprognach()
{
  abl0.asuml0 = suml0;
  printf(F_ABL0,abl0.asuml0);
} /* ----- Ende uprognach */

void upueb()
{
  if (zz >= ZMAX)
  {
    NEUESEITE;
    printf(ABUE);
    LEERZEILE;
    zz = 2;
    abl3.abll3 = vl.gst1;
    strcpy(abl3.abezl3,vl.gst2);
  }
} /* ----- Ende upueb */
