/* bung A33
   Autor: Beringer Alfred
   Stromabrechnung - eindimensionale Tabelle - sequentieller Zugriff
                     (2 Tabellen: Argument- und Wertetabelle).
   Basierend auf bung A31.
 ---------------------------------------------------------------
  EINGABEDATEN: STROMDATEI
       AUFBAU:
         1 -  7 ( 4) ... ABNEHMERNUMMER
         8 - 14 ( 7) ... ZHLERNUMMER
        15 - 19 ( 5) ... ZHLERSTAND ALT
        20 - 24 ( 5) ... ZHLERSTAND NEU
        25 - 78 (54) ... ANDERE DATEN
           79   ( 1) ... TARIF
 ---------------------------------------------------------------
  AUSGABEDATEN: ABRECHNUNGSLISTE
       AUFBAU:
         2 SPALTENBERSCHRIFTEN
         1 LEERZEILE
 
         1 ZEILE FR JEDEN DATENSATZ MIT
             ABNEHMERNUMMER
             ZHLERNUMMER
             ZHLERSTAND ALT
             ZHLERSTAND NEU
             VERBRAUCH (IN KWH)
             TARIF
             PREIS (JE NACH TARIF)
             ZAHLUNGSBETRAG
 
  PRO SEITE MAXIMAL 22 ZEILEN
      (EINSCHL. BERSCHRIFTEN + LEERZEILE).
  BERSCHRIFT NIE ALLEIN AUF EINER SEITE.
 ---------------------------------------------------------------
  DER PREIS WIRD AUS ZWEI TABELLEN (TARIF - PREIS) ERMITTELT.
 ---------------------------------------------------------------
*/

#include <conio.h>
#include <stdio.h>
#include <string.h>
#include "..\\Headerdateien\\clrscr.h"
#include "..\\Headerdateien\\makros.h"

#include "..\\Headerdateien\\strom-EBER.h"

#define EINGABEDATEI  "..\\Dateien\\strom.datC"

#define ZZG     22
#define TANZAHL 5

#define UEB1    "ABNEHMER-  ZAEHLER- ZAEHLERSTAND VERBRAUCH  TARIF  PREIS  ZAHLUNGS-\n"
#define UEB2    "  NUMMER   NUMMER    ALT   NEU     (KWH)          PRO KWH   BETRAG \n"
#define F_ABER  " %s   %s  %5ld %5ld    %5ld      %c   % 5.2f % 10.2f \n"
#define F_ABERF " %s   %s  %5ld %5ld    %5ld      %c   %s \n"

struct ABER
{
  char     aanr[7+1],
           aznr[7+1];
  long int azsalt,
           azsneu,
           averbr;
  char     ata;
  float    apreis,
           azbet;
};

struct ABERF
{
  char     aanr[7+1],
           aznr[7+1];
  long int azsalt,
           azsneu,
           averbr;
  char     ata;
  char     aftext[14+1];
};

union UNION_AB
{
  ABER  aber;
  ABERF aberf;
};

void upaber (EBER eber,
             long int &verbr,
             UNION_AB &ab);
void upueber(short int &zz);
void upsuch (EBER eber,
             float &preis);

void main()
{
  FILE *STROM;
  //    ABRECH = Standardausgabe stdout

  EBER      eber;
  UNION_AB  ab;

  char      ftext[14+1] = "FALSCHER TARIF";

  long int  verbr;
  float     preis,
            zbet;
  short int zz = 99;

  STROM = fopen(EINGABEDATEI,"rb");

  fread(&eber,sizeof(eber),1,STROM);
  while (!feof(STROM))
  {
    upaber(eber,verbr,ab);
    preis = 0.0f;
    upsuch(eber,preis);
    if (preis == 0.0f)
    {
      strcpy(ab.aberf.aftext,ftext);
      if (zz >= ZZG)
        upueber(zz);
      printf(F_ABERF,ab.aberf.aanr,
                     ab.aberf.aznr,
                     ab.aberf.azsalt,
                     ab.aberf.azsneu,
                     ab.aberf.averbr,
                     ab.aberf.ata,
                     ab.aberf.aftext);
      zz++;
    }
    else
    {
      ab.aber.apreis = preis;
      zbet = verbr * preis;
      ab.aber.azbet = zbet;
      if (zz >= ZZG)
        upueber(zz);
      printf(F_ABER,ab.aber.aanr,
                    ab.aber.aznr,
                    ab.aber.azsalt,
                    ab.aber.azsneu,
                    ab.aber.averbr,
                    ab.aber.ata,
                    ab.aber.apreis,
                    ab.aber.azbet);
      zz++;
    }
    fread(&eber,sizeof(eber),1,STROM);
  }

  fclose(STROM);

  _getch();
} /* ----- Ende main */

void upaber(EBER eber,
            long int &verbr,
            UNION_AB &ab)
{
  strcpy(ab.aber.aanr,eber.eanr);
  strcpy(ab.aber.aznr,eber.eznr);
  ab.aber.azsalt = eber.ezsalt;
  ab.aber.azsneu = eber.ezsneu;
  verbr = eber.ezsneu - eber.ezsalt;
  ab.aber.averbr = verbr;
  ab.aber.ata = eber.eta;
  memset(ab.aberf.aftext,' ',sizeof(ab.aberf.aftext)-1);
} /* ----- Ende upaber */

void upueber(short int &zz)
{
  NEUESEITE;
  printf(UEB1);
  printf(UEB2);
  LEERZEILE;
  zz = 3;
} /* ----- Ende upueber */

void upsuch(EBER eber,
            float &preis)
{
  char      taba [TANZAHL] = { '2',   '4',   '5',   '8',   '9'};
  float     tabf [TANZAHL] = { 4.80f, 5.01f, 5.37f, 5.41f, 5.74f };
  short int n;

  n = 1;
  while (n <= TANZAHL)
  {
    if (eber.eta == taba[n-1])
    {
      preis = tabf[n-1];
      n = TANZAHL;
    }
    n++;
  }
} /* ----- Ende upsuch */
