/* bung A36
   Autor: Beringer Alfred
   Umsatzstatistik - eindimensionale Tabelle (Monat).
 ---------------------------------------------------------------
  EINGABEDATEN: VERTRETERUMSATZDATEI
       AUFBAU:
         1 -  2 ( 2) ... VERTRETERNUMMER (01 - 15)
         3 -  4 ( 2) ... MONAT (01 - 12)
         5 - 12 ( 8) ... VERTRETERUMSATZ (2 NACHKOMMASTELLEN)
 
  DIE REIHENFOLGE DER DATEN IST UNBESTIMMT.
 ---------------------------------------------------------------
  AUSGABEDATEN: JAHRESUMSATZSTATISTIKLISTE
       AUFBAU:
         1 HAUPTBERSCHRIFT
         1 LEERZEILE
         1 SPALTENBERSCHRIFT
         1 LEERZEILE
 
         1 ZEILE PRO MONAT MIT
             MONATSNUMMER
             MONATSUMSATZ
 
         1 LEERZEILE UND
         1 GESAMTSUMMENZEILE MIT
             JAHRESUMSATZ
 ---------------------------------------------------------------
*/

#include <conio.h>
#include <stdio.h>
#include <string.h>
#include "..\\Headerdateien\\clrscr.h"
#include "..\\Headerdateien\\makros.h"

#include "..\\Headerdateien\\vertretA3637-EB.h"

#define EINGABEDATEI  "..\\Dateien\\vertreterA3637.datC"

#define ANZMONAT 12

#define ABUE1    "            JAHRESUMSATZSTATISTIK \n"
#define ABUE2    "          MONAT              UMSATZ \n"
#define F_AB     "            %02hd           % 10.2f\n"
#define F_ABL    "          SUMME        % 12.2f\n"
#define F_ABFEL  "FALSCHER MONAT:   %6hd  %6hd  % 10.2f\n"

struct AB
{
  short int amonat;
  float     asum;
};

struct ABL
{
  float agsum;
};

void upva(EB eb, float tsum[]);
void uprognach(float tsum[]);
void upueb();
void upf(EB eb);

void main()
{
  FILE *VERTRET;
  //    ULISTE = Standardausgabe stdout

  EB    eb;
  float tsum [ANZMONAT] = {0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f};

  VERTRET = fopen(EINGABEDATEI,"rb");

  fread(&eb,sizeof(eb),1,VERTRET);
  while (!feof(VERTRET))
  {
    upva(eb,tsum);
    fread(&eb,sizeof(eb),1,VERTRET);
  }
  uprognach(tsum);

  fclose(VERTRET);

  _getch();
} /* ----- Ende main */

void upva(EB eb, float tsum[])
{
  if (eb.emonat < 1)
    upf(eb);
  else
    if (eb.emonat <= ANZMONAT)
      tsum[eb.emonat-1] += eb.eums;
    else
      upf(eb);
} /* ----- Ende upva */

void uprognach(float tsum[])
{
  AB  ab;
  ABL abl;

  short int rmonat;
  float gsum;

  upueb();
  gsum = 0.0f;
  rmonat = 1;
  while (rmonat <= ANZMONAT)
  {
    ab.amonat = rmonat;
    ab.asum = tsum[rmonat-1];
    printf(F_AB,ab.amonat,ab.asum);
    gsum += tsum[rmonat-1];
    rmonat++;
  }
  LEERZEILE;
  abl.agsum = gsum;
  printf(F_ABL,abl.agsum);
} /* ----- Ende uprognach */

void upueb()
{
  NEUESEITE;
  printf(ABUE1);
  LEERZEILE;
  printf(ABUE2);
  LEERZEILE;
} /* ----- Ende upueb */

void upf(EB eb)
{
  printf(F_ABFEL,eb.evnr,eb.emonat,eb.eums);
} /* ----- Ende upf */
