/* bung A37
   Autor: Beringer Alfred
   Umsatzstatistik - zweidimensionale Tabelle (Monat, Vertreter).
 ---------------------------------------------------------------
  EINGABEDATEN: VERTRETERUMSATZDATEI
       AUFBAU:
         1 -  2 ( 2) ... VERTRETERNUMMER (01 - 15)
         3 -  4 ( 2) ... MONAT (01 - 12)
         5 - 12 ( 8) ... VERTRETERUMSATZ (2 NACHKOMMASTELLEN)
 
  DIE REIHENFOLGE DER DATEN IST UNBESTIMMT.
 ---------------------------------------------------------------
  AUSGABEDATEN: JAHRESUMSATZSTATISTIKLISTE
       AUFBAU:
         1 HAUPTBERSCHRIFT
         1 LEERZEILE
         1 SPALTENBERSCHRIFT
         1 LEERZEILE
 
         1 ZEILE PRO VERTRETER MIT
             VERTRETERNUMMER
             12 MONATSUMSTZE DES VERTRETERS
             JAHRESUMSATZ DES VERTRETERS
 
         1 LEERZEILE UND
         1 GESAMTSUMMENZEILE MIT
             12 MONATSGESAMTUMSTZE
             JAHRESGESAMTUMSATZ
 ---------------------------------------------------------------
*/

#include <conio.h>
#include <stdio.h>
#include <string.h>
#include "..\\Headerdateien\\clrscr.h"
#include "..\\Headerdateien\\makros.h"

#include "..\\Headerdateien\\vertretA3637-EB.h"

#define EINGABEDATEI  "..\\Dateien\\vertreterA3637.datC"

#define ZMAX     20

#define ANZMONAT 12
#define ANZVNR   15

#define ABUE1    "                        JAHRESUMSATZSTATISTIK \n"
#define ABUE2    "         01        02        03        04        05        06\n"
#define ABUE3    "         07        08        09        10        11        12          SUMME\n"
#define F_ABFEL  "FALSCHER MONAT ODER VERTRETER:   %06hd  %06hd  % 10.2f\n"

static short int zz = 99;

static struct AB
{
  short int avnr;
  float     asum[ANZMONAT],
            azsum;
} ab;

static struct ABL
{
  float agsum[ANZMONAT],
        agzsum;
} abl;

static float t2sum [ANZVNR][ANZMONAT],
             t1sum [ANZMONAT];

static FILE *VERTRET;
//           ULISTE = Standardausgabe stdout

void uprogvor   ();
void upva       (EB eb);
void uprognach  ();
void upvnrvor   ();
void upmonatvor (short int rvnr,
                 float &gsum);
void uptabeinzel(short int rvnr,
                 short int rmonat,
                 float &gsum);
void upmonatnach(float gsum);
void upvnrnach  ();
void upueb      ();
void upf        (EB eb);

void main()
{
  EB eb;

  VERTRET = fopen(EINGABEDATEI,"rb");

  uprogvor();
  fread(&eb,sizeof(eb),1,VERTRET);
  while (!feof(VERTRET))
  {
    upva(eb);
    fread(&eb,sizeof(eb),1,VERTRET);
  }
  uprognach();

  fclose(VERTRET);

  _getch();
} /* ----- Ende main */

void uprogvor()
{
  short int rvnr,
            rmonat;

  rvnr = 1;
  while (rvnr <= ANZVNR)
  {
    rmonat = 1;
    while (rmonat <= ANZMONAT)
    {
      t2sum[rvnr-1][rmonat-1] = 0.0f;
      rmonat++;
    }
    rvnr++;
  }
} /* ----- Ende uprogvor */

void upva(EB eb)
{
  if (eb.evnr < 1)
    upf(eb);
  else
    if (eb.evnr > ANZVNR)
      upf(eb);
    else
      if (eb.emonat < 1)
	upf(eb);
      else
	if (eb.emonat > ANZMONAT)
	  upf(eb);
	else
	  t2sum[eb.evnr-1][eb.emonat-1] += eb.eums;
} /* ----- Ende upva */

void uprognach()
{
  float gsum;
  short int rvnr,
            rmonat;

  upueb();
  upvnrvor();
  rvnr = 1;
  while (rvnr <= ANZVNR)
  {
    upmonatvor(rvnr,gsum);
    rmonat = 1;
    while (rmonat <= ANZMONAT)
    {
      uptabeinzel(rvnr,rmonat,gsum);
      rmonat++;
    }
    upmonatnach(gsum);
    LEERZEILE;
    zz = zz + 3;
    if (zz >= ZMAX)
      upueb();
    rvnr++;
  }
  upvnrnach();
} /* ----- Ende uprognach */

void upvnrvor()
{
  short int rmonat = 1;
  while (rmonat <= ANZMONAT)
  {
    t1sum[rmonat-1] = 0.0f;
    rmonat++;
  }
} /* ----- Ende upvnrvor */

void upmonatvor(short int rvnr,
                float &gsum)
{
  ab.avnr = rvnr;
  printf("%02hd ",ab.avnr);
  gsum = 0.0f;
} /* ----- Ende upmonatvor */

void uptabeinzel(short int rvnr,
                 short int rmonat,
                 float &gsum)
{
  ab.asum[rmonat-1] = t2sum[rvnr-1][rmonat-1];
  if (rmonat == 7)
  {
    LEERZEILE;
    printf("   ");
  }
  printf("% 9.1f ",ab.asum[rmonat-1]);
  gsum = gsum + t2sum[rvnr-1][rmonat-1];
  t1sum[rmonat-1] = t1sum[rmonat-1] + t2sum[rvnr-1][rmonat-1];
} /* ----- Ende uptabeinzel */

void upmonatnach(float gsum)
{
  ab.azsum = gsum;
  printf("  %12.1f\n",ab.azsum);
} /* ----- Ende upmonatnach */

void upvnrnach()
{
  float gsum = 0.0f;
  short int rmonat = 1;

  printf("\nSU ");
  while (rmonat <= ANZMONAT)
  {
    abl.agsum[rmonat-1] = t1sum[rmonat-1];
    if (rmonat == 7)
    {
      LEERZEILE;
      printf("   ");
    }
    printf("%9.1f ",abl.agsum[rmonat-1]);
    gsum = gsum + t1sum[rmonat-1];
    rmonat++;
  }
  abl.agzsum = gsum;
  printf("  %12.1f\n",abl.agzsum);
} /* ----- Ende upvnrnach */

void upueb()
{
  NEUESEITE;
  printf(ABUE1);
  LEERZEILE;
  printf(ABUE2);
  printf(ABUE3);
  LEERZEILE;
  zz = 5;
} /* ----- Ende upueb */

void upf(EB eb)
{
  printf(F_ABFEL,eb.evnr,eb.emonat,eb.eums);
} /* ----- Ende upf */
