/* bung A38
   Autor: Beringer Alfred
   Theaterliste - Sortierfolge, zweifacher Gruppenwechsel + eindimensionale Tabelle.
 ---------------------------------------------------------------
  EINGABEDATEN: THEATERDATEI
       AUFBAU:
           1     ( 1) ... KENNZIFFER FR SPIELORT
                             (ES GIBT 8 SPIELORTE)
         2 -  40 (39) ... TITEL DES THEATERSTCKS
        41 -  60 (20) ... NAME DES SCHAUSPIELERS
        61 -  75 (15) ... STAMMTHEATER DES SCHAUSPIELERS
           76    ( 1) ... GEHALTSKATEGORIE
        77 -  80 ( 4) ... GEHALTSZUSCHLAG (2 NACHKOMMASTELLEN)
        81 - 103 (23) ... ROLLE (DES SCHAUSPIELERS IM STCK)
       104 - 111 ( 8) ... PREMIERENDATUM IN DER FORM JJJJMMTT
       112 - 119 ( 8) ... LETZTER SPIELTAG IN FORM JJJJMMTT
 
  DIE EINGABEDATEN SIND AUFSTEIGEND SORTIERT NACH DEM
     STAMMTHEATER,
        INNERHALB EINES STAMMTHEATERS NACH DEM
     NAMEN DES SCHAUSPIELERS,
        INNERHALB DES SCHAUSPIELERNAMENS NACH DEM
     TITEL DES THEATERSTCKS
        UND INNERHALB DES THEATERSTCKS NACH DER
     ROLLE DES SCHAUSPIELERS.
 ---------------------------------------------------------------
  AUSGABEDATEN: ROLLENLISTE
       AUFBAU:
         1 SPALTENBERSCHRIFT UND
         1 LEERZEILE
 
    PRO THEATER - BEGINNEND AUF EINER NEUEN SEITE - FR JEDEN
    SEINER STAMMSPIELER PRO SPIELORT, IN DEM DIESER SCHAUSPIELER
    ZUMINDEST EINMAL 1 ROLLE GESPIELT HAT, 1 ZEILE MIT:
             STAMMTHEATER
             NAME DES SCHAUSPIELERS
             SPIELORT
             ANZAHL DER ROLLEN, DIE DER SCHAUSPIELER AM
                           SPIELORT GESPIELT HAT
 
    PRO STAMMTHEATER 1 SUMMENZEILE MIT:
             ANZAHL SEINER SCHAUSPIELER
 
    AM ENDE DER VERARBEITUNG 1 GESAMTSUMMENZEILE MIT:
             GESAMTANZAHL ALLER SCHAUSPIELER
 
  PRO SEITE MAXIMAL 20 ZEILEN
      (EINSCHL. BERSCHRIFT + LEERZEILE).
  DIE BERSCHRIFT SOLL NIE ALLEIN AUF EINER SEITE STEHEN.
 ---------------------------------------------------------------
*/

#include <conio.h>
#include <stdio.h>
#include <string.h>
#include "..\\Headerdateien\\clrscr.h"
#include "..\\Headerdateien\\makros.h"

#include "..\\Headerdateien\\theater-EBER.h"

#define EINGABEDATEI  "..\\Dateien\\theater.datC"

#define ZZMAX    20
#define ANZKENNZ 8
#define HIGH     '\xff'
#define LOW      '\x00'

#define L0LEN     1
#define L1LEN    17
#define L2LEN    38

#define ABUE     "STAMMTHEATER       SCHAUSPIELER            SPIELORT        ANZAHL ROLLEN\n"
#define F_ABL2   "%s    %s    %s      %2hd \n"
#define F_ABL1   "%s HAT  %3hd  SCHAUSPIELER. \n"
#define F_ABL0   "            ES GIBT %4hd  SCHAUSPIELER IN WIEN. \n"
#define F_ABFEL  "FALSCHES KENNZEICHEN: %c  %s  %s\n"

static EBER eber;

static struct L
{
  char eof,
       gst1[15+1],
       gst2[20+1];
} el,vl;

static struct ABL2
{
  char      astamml2[15+1],
            anamel2 [20+1],
            aortl2  [15+1];
  short int asuml2;
} abl2;

static struct ABL1
{
  char      astamml1[15+1];
  short int asuml1;
} abl1;

static struct ABL0
{
  short int asuml0;
} abl0;

static short int suml0,
                 suml1,
                 tsuml2[ANZKENNZ];

static char tort[ANZKENNZ][15+1] = { "STAATSOPER     ",
                                     "VOLKSOPER      ",
                                     "KAMMEROPER     ",
                                     "BURGTHEATER    ",
                                     "RAIMUNDTHEATER ",
                                     "JOSEFSTADT     ",
                                     "KAMMERSPIELE   ",
                                     "VOLKSTHEATER   "  };

static FILE *THEATER;
//           ROLLEN = Standardausgabe stdout

void uprogvb();
void uplesen();
void uphgvb(short int &zz);
void upgrvb();
void upeinzel();
void upgrnb(short int &zz);
void uphgnb();
void uprognb();
void upschr(short int &zz);
void upueber(short int &zz);
void upf();

void main()
{
  short int zz;

  THEATER = fopen(EINGABEDATEI,"rb");

  uprogvb();
  uplesen();
  while (memcmp(&el,&vl,L0LEN) == 0)
  {
    uphgvb(zz);
    while (memcmp(&el,&vl,L1LEN) == 0)
    {
      upgrvb();
      while (memcmp(&el,&vl,L2LEN) == 0)
      {
        upeinzel();
        uplesen();
      }
      upgrnb(zz);
    }
    uphgnb();
  }
  uprognb();

  fclose(THEATER);

  _getch();
} /* ----- Ende main */

void uplesen()
{
  fread(&eber,sizeof(eber),1,THEATER);
  if (feof(THEATER))
    el.eof = HIGH;
  else
  {
    strcpy(el.gst1,eber.estamm);
    strcpy(el.gst2,eber.ename);
  }
} /* ----- Ende uplesen */

void uprogvb()
{
  el.eof = LOW;
  suml0 = 0;
  vl.eof = el.eof;
} /* ----- Ende uprogvb */

void uphgvb(short int &zz)
{
  zz = ZZMAX;
  strcpy(abl2.astamml2,eber.estamm);
  strcpy(abl1.astamml1,eber.estamm);
  suml1 = 0;
  strcpy(vl.gst1,el.gst1);
} /* ----- Ende uphgvb */

void upgrvb()
{
  short int rkennz = 1;
  while (rkennz <= ANZKENNZ)
  {
    tsuml2[rkennz-1] = 0;
    rkennz++;
  }
  strcpy(abl2.anamel2,eber.ename);
  strcpy(vl.gst2,el.gst2);
} /* ----- Ende upgrvb */

void upeinzel()
{
  short int rkennz;
  
  rkennz = eber.ekennz - '0';
  if (rkennz < 1)
    upf();
  else
    if (rkennz > ANZKENNZ)
      upf();
    else
      tsuml2[rkennz-1]++;
} /* ----- Ende upeinzel */

void upgrnb(short int &zz)
{
  short int rkennz = 1;
  while (rkennz <= ANZKENNZ)
  {
    if (tsuml2[rkennz-1] != 0)
    {
      strcpy(abl2.aortl2,tort[rkennz-1]);
      abl2.asuml2 = tsuml2[rkennz-1];
      upschr(zz);
    }
    rkennz++;
  }
  LEERZEILE;
  zz++;
  suml1++;
} /* ----- Ende upgrnb */

void uphgnb()
{
  abl1.asuml1 = suml1;
  printf(F_ABL1,abl1.astamml1,abl1.asuml1);
  suml0 = suml0 + suml1;
} /* ----- Ende uphgnb */

void uprognb()
{
  LEERZEILE;
  abl0.asuml0 = suml0;
  printf(F_ABL0,abl0.asuml0);
} /* ----- Ende uprognb */

void upschr(short int &zz)
{
  if (zz >= ZZMAX)
    upueber(zz);
  printf(F_ABL2,abl2.astamml2,abl2.anamel2,abl2.aortl2,abl2.asuml2);
  zz++;
  memset(abl2.astamml2,' ',strlen(abl2.astamml2));
  memset(abl2.anamel2,' ',strlen(abl2.anamel2));
} /* ----- Ende upschr */

void upueber(short int &zz)
{
  NEUESEITE;
  printf(ABUE);
  LEERZEILE;
  zz = 2;
  strcpy(abl2.astamml2,vl.gst1);
  strcpy(abl2.anamel2,vl.gst2);
} /* ----- Ende upueber */

void upf()
{
  printf(F_ABFEL,eber.ekennz,eber.ename,eber.estamm);
} /* ----- Ende upf */
