/* bung A39 (Version 1)
   Autor: Beringer Alfred
   Mischlogik - Artikelstze ndern.
 ---------------------------------------------------------------
  EINGABEDATEN: ARTIKELDATEI
       AUFBAU:
         1 -  4 ( 4) ... ARTIKELNUMMER
         5 - 24 (20) ... ARTIKELBEZEICHNUNG
        25 - 31 ( 7) ... EINZELPREIS
        32 - 36 ( 5) ... BESTANDSMENGE
        37 - 55 (19) ... SONSTIGE DATEN
 
  EINGABEDATEN: NDERUNGSDATEI
       AUFBAU:
         1 -  4 ( 4) ... ARTIKELNUMMER
         5 - 11 ( 7) ... NEUER EINZELPREIS
 
  BEIDE DATEIEN SIND AUFSTEIGEND SORTIERT NACH DER
  ARTIKELNUMMER.
  PRO ARTIKELNUMMER GIBT ES NUR 1 EINGABEDATENSATZ.
 ---------------------------------------------------------------
  AUSGABEDATEN: AKTUALISIERTE ARTIKELDATEI
 
                FEHLERPROTOKOLL
                      ZU NDERNDE ARTIKELNUMMER NICHT VORHANDEN
                      SORTIERFOLGEFEHELER IN DER NDERUNGSDATEI
 ---------------------------------------------------------------
*/

#include <conio.h>
#include <stdio.h>
#include <string.h>
#include "..\\Headerdateien\\clrscr.h"
#include "..\\Headerdateien\\makros.h"

#include "..\\Headerdateien\\artikel-BBER.h"
#include "..\\Headerdateien\\kaender-KBER.h"

#define DATEIALT  "..\\Dateien\\artikel.datC"
#define DATEINEU  "..\\Dateien\\neuband.datC"
#define DATEI     "..\\Dateien\\kaender.datC"

#define ZZGF   22
#define HIGH   "\xff\xff\xff\xff"

#define FUEB   "FEHLERPROTOKOLL\n"
#define F_FBER "%s %s\n"
#define FEHL1  "ARTIKEL NICHT VORHANDEN       "

struct FBER
{
  char fnr  [ 4+1],
       fmeld[30+1];
};

static FILE *ALTBAND;
static FILE *NEUBAND;
static FILE *KAENDER;
//           FEHLER = Standardausgabe stdout

void uplesaltband(short int &eofz,
                  BBER &bber);
void upleskaender(short int &eofz,
                  KBER &kber);
void upschrf     (short int &zzf,
                  FBER &fber,
                  KBER kber);

void main()
{
  BBER bber;
  KBER kber;
  FBER fber;

  short int zzf = 99,
            eofz;

  ALTBAND = fopen(DATEIALT,"rb");
  NEUBAND = fopen(DATEINEU,"wb");
  KAENDER = fopen(DATEI,"rb");

  eofz = 0;
  uplesaltband(eofz,bber);
  upleskaender(eofz,kber);
  while (eofz < 2)
  {
    if (strcmp(bber.bnr,kber.knr) < 0)
    {
      fwrite(&bber,sizeof(bber),1,NEUBAND);
      uplesaltband(eofz,bber);
    }
    else
      if (strcmp(bber.bnr,kber.knr) == 0)
      {
        bber.bpreis = kber.kpreis;
        fwrite(&bber,sizeof(bber),1,NEUBAND);
        uplesaltband(eofz,bber);
        upleskaender(eofz,kber);
      }
      else
      {
        strcpy(fber.fmeld,FEHL1);
        upschrf(zzf,fber,kber);
        upleskaender(eofz,kber);
      }
  }

  fclose(ALTBAND);
  fclose(NEUBAND);
  fclose(KAENDER);

  _getch();
} /* ----- Ende main */

void uplesaltband(short int &eofz, BBER &bber)
{
  fread(&bber,sizeof(bber),1,ALTBAND);
  if (feof(ALTBAND))
  {
    strcpy(bber.bnr,HIGH);
    eofz++;
  }
} /* ----- Ende uplesaltband */

void upleskaender(short int &eofz, KBER &kber)
{
  fread(&kber,sizeof(kber),1,KAENDER);
  if (feof(KAENDER))
  {
    strcpy(kber.knr,HIGH);
    eofz++;
  }
} /* ----- Ende upleskaender */

void upschrf(short int &zzf, FBER &fber, KBER kber)
{
  strcpy(fber.fnr,kber.knr);
  if (zzf >= ZZGF)
  {
    NEUESEITE;
    printf(FUEB);
    LEERZEILE;
    zzf = 2;
  }
  printf(F_FBER,fber.fnr,fber.fmeld);
  zzf++;
} /* ----- Ende upschrf */
