/* bung A40 (Version 2)
   Autor: Beringer Alfred
   Mischlogik - Artikelstze lschen,
                zustzliche Ausgabe der aktuellen Artikelliste.
 ---------------------------------------------------------------
  EINGABEDATEN: ARTIKELDATEI
       AUFBAU:
         1 -  4 ( 4) ... ARTIKELNUMMER
         5 - 24 (20) ... ARTIKELBEZEICHNUNG
        25 - 31 ( 7) ... EINZELPREIS
        32 - 36 ( 5) ... BESTANDSMENGE
        37 - 55 (19) ... SONSTIGE DATEN
 
  EINGABEDATEN: LSCHDATEI
       AUFBAU:
         1 -  4 ( 4) ... ARTIKELNUMMER
 
  BEIDE DATEIEN SIND AUFSTEIGEND SORTIERT NACH DER
  ARTIKELNUMMER.
  PRO ARTIKELNUMMER GIBT ES NUR 1 EINGABEDATENSATZ.
 ---------------------------------------------------------------
  AUSGABEDATEN: AKTUALISIERTE ARTIKELDATEI
 
                AKTUALISIERTE ARTIKELLISTE
 
                FEHLERPROTOKOLL
                      ZU LSCHENDE ARTIKELNUMMER NICHT VORHANDEN
                      SORTIERFOLGEFEHLER IN DER LSCHDATEI
 ---------------------------------------------------------------
*/

#include <conio.h>
#include <stdio.h>
#include <string.h>
#include "..\\Headerdateien\\clrscr.h"
#include "..\\Headerdateien\\makros.h"

#include "..\\Headerdateien\\artikel-BBER.h"
#include "..\\Headerdateien\\kloesch-KBER.h"

#define DATEIALT  "..\\Dateien\\artikel.datC"
#define DATEINEU  "..\\Dateien\\neuband.datC"
#define DATEI     "..\\Dateien\\kloesch.datC"

#define ZZG    22
#define ZZGF   22

#define HIGH   '\xff'
#define LOW    '\x00'

#define ABUEB  "ARTIKELLISTE\n"
#define F_ABER "%s %s  %7.2f   %s\n"
#define TEXT   "GELOESCHT"

#define FUEB   "FEHLERPROTOKOLL\n"
#define F_FBER "%s %s\n"
#define FEHL1  "ARTIKEL NICHT VORHANDEN       "
#define FEHL2  "SORTIERFOLGEFEHLER            "

static BBER bber;
static KBER kber;

/**************************/
static struct L1
{
  char eof,
       sort1 [ 4+1];
} bl1,kl1,vl1;
/**************************/

static struct ABER
{
  char  anr  [ 4+1],
        abez [20+1];
  float apreis;
  char  atext[ 9+1];
} aber;

static struct FBER
{
  char fnr  [ 4+1],
       fmeld[30+1];
} fber;

static FILE *ALTBAND;
static FILE *NEUBAND;
static FILE *KLOESCH;
/*           FEHLER  und
             ARTLIST = Standardausgabe stdout */

void uplesaltband(short int &dz);
void upleskloesch(short int &dz);
void uprogvor    (short int &dz);
void upmisch     (short int &dz,
                  short int &zz,
                  short int &zzf);
void upschr      (short int &zz);
void upueb       (short int &zz);
void upschrf     (short int &zzf);
void upuebf      (short int &zzf);

void main()
{
  short int zz  = 99,
            zzf = 99,
            dz;

  ALTBAND = fopen(DATEIALT,"rb");
  NEUBAND = fopen(DATEINEU,"wb");
  KLOESCH = fopen(DATEI,"rb");

  uprogvor(dz);
  uplesaltband(dz);
  upleskloesch(dz);
  while (dz > 0)
  {
    if (memcmp(&kl1,&vl1,sizeof(struct L1)) <= 0)
    {
      strcpy(fber.fmeld,FEHL2);
      upschrf(zzf);
      upleskloesch(dz);
    }
    else
      upmisch(dz,zz,zzf);
  }

  fclose(ALTBAND);
  fclose(NEUBAND);
  fclose(KLOESCH);

  _getch();
} /* ----- Ende main */

void uplesaltband(short int &dz)
{
  fread(&bber,sizeof(bber),1,ALTBAND);
  if (feof(ALTBAND))
  {
    bl1.eof = HIGH;
    dz--;
  }
  else
    strcpy(bl1.sort1,bber.bnr);
} /* ----- Ende uplesaltband */

void upleskloesch(short int &dz)
{
  fread(&kber,sizeof(kber),1,KLOESCH);
  if (feof(KLOESCH))
  {
    kl1.eof = HIGH;
    dz--;
  }
  else
    strcpy(kl1.sort1,kber.knr);
} /* ----- Ende upleskloesch */

void uprogvor(short int &dz)
{
  bl1.eof = LOW;
  kl1.eof = LOW;
  memset(&vl1,LOW,sizeof(struct L1));
  dz = 2;
} /* ----- Ende uprogvor */

void upmisch(short int &dz,
             short int &zz,
             short int &zzf)
{
  if (memcmp(&bl1,&kl1,sizeof(struct L1)) < 0)
  {
    upschr(zz);
    fwrite(&bber,sizeof(bber),1,NEUBAND);
    uplesaltband(dz);
  }
  else
    if (memcmp(&bl1,&kl1,sizeof(struct L1)) == 0)
    {
      strcpy(aber.atext,TEXT);
      upschr(zz);
      uplesaltband(dz);
      strcpy(vl1.sort1,kl1.sort1);
      upleskloesch(dz);
    }
    else
    {
      strcpy(fber.fmeld,FEHL1);
      upschrf(zzf);
      strcpy(vl1.sort1,kl1.sort1);
      upleskloesch(dz);
    }
} /* ----- Ende upmisch */

void upschr(short int &zz)
{
  strcpy(aber.anr,bber.bnr);
  strcpy(aber.abez,bber.bbez);
  aber.apreis = bber.bpreis;
  if (zz >= ZZG)
    upueb(zz);
  printf(F_ABER,aber.anr,aber.abez,aber.apreis,aber.atext);
  zz++;
  aber.atext[0] = 0;
} /* ----- Ende upschr */

void upueb(short int &zz)
{
  NEUESEITE;
  printf(ABUEB);
  LEERZEILE;
  zz = 2;
} /* ----- Ende upueb */

void upschrf(short int &zzf)
{
  strcpy(fber.fnr,kber.knr);
  if (zzf >= ZZGF)
    upuebf(zzf);
  printf(F_FBER,fber.fnr,fber.fmeld);
  zzf++;
} /* ----- Ende upschrf */

void upuebf(short int &zzf)
{
  NEUESEITE;
  printf(FUEB);
  LEERZEILE;
  zzf = 2;
} /* ----- Ende upuebf */
